
;                            Ŀ
;			     	  8086 Code    
;                            

_CodeSegSize	= 16					;used by emit macros

;===============

include rmemit.asm

;===============

;

AlmostInReal:

                cli

    IF _VME

;Disable VME.

		mov	eax, CR4
		and	eax, not VME
		mov	CR4, eax

    ENDIF


;Disable protect-mode.

		mov	eax, CR0
		and	eax, not (pe or ts)
                mov     CR0, eax

;Flush prefetch Q through a direct far jump since the following instructions
;were fetched in protect-mode.

		jmp	far ptr Flush_Q_of_PM

Flush_Q_of_PM	label far

;Set SS and DS.

		mov	ax, V86MonStackSeg
                mov     SS, ax
		mov	sp, offset Stack_Real
		mov	ax, V86MonDataSeg
		mov	DS, ax

;Load the IDTR with the base and limit of the 8086 IDT.

		lidt	[IDT_Real_fword]

        ;---    Now completely in real-mode. Ready to run 8086 code.    ---

_Emit = 1

		.IF	[UFO]

		error	<UFO was sighted.>
		error	<Opcode: >, nocr
		movzx	ax, @8 [UFO_Opcode]
		error_ax
		error	<Vector: >, nocr
		mov	eax, [Vector]
		error_eax
		error	<CS:  >, nocr
		mov	eax, [UFO_CS]
		error_eax
		error	<EIP: >, nocr
		mov	eax, [UFO_EIP]
		error_eax
		error	<EFL: >, nocr
		mov	eax, [UFO_EFL]
		error_eax
		error	<(EIP is reported past any prefixes)>

		.ENDIF

		.IF	[Exception]

		error	<Exception #>, nocr
		mov	ax, @16 [Vector]
		error_ax
		mov	eax, [Exception_EIP]
		error	<EIP : >, nocr
		error_eax
		mov	eax, [Exception_CS]
		error	<CS  : >, nocr
		error_eax

		.ENDIF

		.IF	[UnexpectedError]

		error	<Unexpected error occured. Program terminated.>
		@DOSExit 1

		.ENDIF

		emit	<Elasped clocks: >, nocr
		mov	eax, [TSC_End]
		sub	eax, [TSC_Start]
		emit_eax nocr

		emit	< >
		emit	< >

		sti
		@DOSExit

;===============

include beginv86.asm
