
;
;
;			Ŀ
;			  Discardable Code/Data  
;			

DiscardableSeg	segment para public use16 'CODE'
		assume	DS:V86MonDataSeg, SS:V86MonStackSeg, ES:nothing

_CodeSegSize	= 16					;used by emit macros

;===============

Startup 	proc	far

.8086

		mov	ax, V86MonDataSeg
                mov     DS, ax
		mov	ES, ax
		cld

;Set cursor to DOS's command prompt cursor.

                call    SyncCursorWithBIOS

_Emit = 1

		emit	< >
IFE _VME
		emit	<* V86 Mode Monitor/8086 Instruction Mix 1.0 *>
ELSE
		emit	<* EV86 Mode Monitor/8086 Instruction Mix 1.0 *>
ENDIF
		emit	< >
		emit	<By Jim Brooks, Copyright (c) 1995>
		emit	<Internet: 103151.1307@compuserve.com>
		emit	< >

		call	TestFor32BitCPU
		call	Emit_CPU_NPX

.586P

;Now 386 instructions can be used.

;The procedure TestFor32BitCPU will set the variable CPUID_Implemented if
;the CPUID instruction is implemented. If CPUID itself is not implemented,
;assume neither is VME nor TSC.

		.IF	[CPUID_Implemented] == 0

		error	<The CPUID instruction is not implemented in this CPU.>
		error	<Assuming neither is VME nor TSC, which are required by this program.>
		@DOSExit 1

		.ENDIF

;Test if VME and TSC are implemented using the CPUID instruction.
;(Credit to Christian Ludloff for TSC information).

		mov	eax, 1
		cpuid

		.IF	!(edx & 10b)

		emit	<VME is not implemented in this CPU.>
		@DOSExit 1

		.ENDIF

		.IF	!(edx & 10000b)

		emit	<Time stamp counter is not implemented in this CPU.>
		@DOSExit 1

		.ENDIF

;Check if the CPU is in protect-mode using SMSW, as it is not a privileged
;instruction. Note that using MOV R32,CR0 is a privileged instruction,
;and is not emulated by some memory managers such as EMM386, and using
;PUSHFD to examine the VM bit in EFLAGS will not work because the CPU
;always clears the VM bit in the stack image when in V86 mode.

                smsw    ax
                test    ax, pe
		jz	NotInV86Mode

		error	<The CPU is not in real-mode.>

                @DosExit 1
NotInV86Mode:

		cli

                call    SegmentToLinear
IF _VME
		emit	<Virtual-8086 Mode Extensions are enabled.>
ENDIF
		emit	<Beginning execution of 8086 instruction mix...>

		ret

_Emit = 0

Startup 	endp

;===============

SegmentToLinear proc

;-------------------------------------------------------------------------------
;Translates an 8086-style segment to a 24-bit linear address, and is intended
;only for DESCRIPTOR and TABLE REGISTER ADDRESSES. Note while it's true
;that both are 32-bit, they only have similar locations to 24-bits.
;32-bit descriptors unconventionally put the high byte of the 32-bit address
;2 bytes ahead where it normally would be, because these 2 bytes were previously
;defined by the 80286. 24-bit is adequate, but need to define high byte
;as 0 in data declaration.
;-------------------------------------------------------------------------------

		mov	si, offset ThunkTable
                mov     cx, ThunkCount
ThunkLoop:
		lods	@16 CS:[si]		;offset of fixup location
		mov	bx, ax			;bx=base addr (desc+2)
		lods	@16 CS:[si]		;segment to add on
		movzx	edx, ax 		;need 32 bit register
		shl	edx, 4			;segment to linear
		shld	eax, edx, 16		;high byte to eax
		add	[bx], dx		;add onto the offset already in [bx]
                adc     [bx+2], al
                loop    ThunkLoop

                ret

SegmentToLinear endp

;

;------------------------------------------------------------------------------

;16-bit segment address to 24-bit linear address conversion (thunk) table.

ThunkTable	dw offset16 Thunk_Code0 		;8086 off
		dw V86MonCodeSeg32			;8086 seg

		dw offset16 Thunk_Data0
		dw V86MonDataSeg

		dw offset16 Thunk_Stack0
		dw V86MonStackSeg

		dw offset16 Thunk_GDT
		dw V86MonDataSeg

		dw offset16 Thunk_IDT_V86
		dw V86MonDataSeg

		dw offset16 Thunk_InitTSS		;initial TSS is really the RM stack
		dw V86MonStackSeg

		dw offset16 Thunk_SchedTSS
		dw V86MonDataSeg

		dw offset16 Thunk_RealCS
		dw V86MonCodeSeg16

ThunkCount	= ($ - ThunkTable) / 4
.errnz          ($-ThunkTable) mod 4,<Conversion table length not a multiple of 4>

;===============

include testcpu.asm

;===============

DiscardableSeg ends
