
;                     Ŀ
;                       IOPL Sensitive Instructions  
;                     

comment %
     ͸
     3322222222221111111 111          
     1098765432109876543 2109876543210
     Ĵ
                        I             
     0000000000IVVAVR0N O ODITSZ0A0P1C
               DIICMF T P FFFFFF F F F
                PF      L             
     

V86-mode IOPL-sensitive instruction set:

    CLI, STI
    PUSHF/D, POPF/D
    INT n               (excludes INT1,INT3,INTO)
    IRETW/D
    (Note IN/INS/OUT/OUTS are not IOPL-sensitive in V86 mode)

Procedures expect:

 GS:ESI = V86 CS:IP
 GS:EBP = V86 SS:SP
 GS	= linear address of V86 task address space.

%

;---------------

V86_GPF_Handler_STI:

		inc	@16 [esp0_v86_eip]		;adjust IP past

		mov	@TD_V86._IF, ifl		;set IF in V86 TD

		jmp	RunV86Task

V86_GPF_Handler_CLI:

		inc	@16 [esp0_v86_eip]		;adjust IP past

		mov	@TD_V86._IF, 0			;clear IF in V86 TD

		jmp	RunV86Task

;---------------

V86_GPF_Handler_PUSHF:

		mov	eax, @32 [esp0_v86_eflags]	;V86 EFLAGS on CPL0 stack
		 sub	 @16 [esp0_v86_esp], 2		;allocate word on V86 stack
		and	eax, not ifl			;mask IF
		or	eax, @TD_V86._IF		;use virtual IF
		 inc	 @16 [esp0_v86_eip]		;adjust IP past PUSHF
                mov     @16 GS:[ebp-2], ax              ;"push" to V86 stack

		jmp	RunV86Task

;---------------

V86_GPF_Handler_POPF:

		mov	eax, @32 [esp0_v86_eflags]	;EFLAGS on V86 CPL0 stack
                movzx   edx, @16 GS:[ebp]               ;FLAGS on V86 stack (zero-extended to 32-bits)
                and     eax,     _Protected_V86_EFLAGS
                 mov    ebx, edx
                and     edx, not _Protected_V86_EFLAGS
		add	@16 [esp0_v86_esp], 2		;pop FLAGS off V86 stack
                or      eax, edx
		inc	@16 [esp0_v86_eip]		;adjust IP past
		 and	ebx, ifl			;include IF
		mov	@32 [esp0_v86_eflags], eax	;FLAGS (16-bits) affected only
                 mov    @TD_V86._IF, ebx                ;set/clear TD_V86_IF accordingly.

		jmp	RunV86Task

;---------------

V86_GPF_Handler_IRETW:

;Pop CS:IP.
                mov     eax, @32 GS:[ebp]               ;=CS:IP
		mov	@16 [esp0_v86_eip], ax
                shr     eax, 16
		mov	@16 [esp0_v86_cs], ax
;Pop FLAGS.

		mov	eax, @32 [esp0_v86_eflags]	;EFLAGS on V86 CPL0 stack
		movzx	edx, @16 GS:[ebp+2+2]		;FLAGS on V86 stack (zero-extended to 32-bits)
                and     eax,     _Protected_V86_EFLAGS
                 mov    ebx, edx
                and     edx, not _Protected_V86_EFLAGS
		add	@16 [esp0_v86_esp], 2+2+2	;pop {IP,CS,FLAGS} from V86 stack
                or      eax, edx
		 and	ebx, ifl			;include IF
		mov	@32 [esp0_v86_eflags], eax	;FLAGS (16-bits) affected only
                 mov    @TD_V86._IF, ebx                ;set/clear TD_V86_IF accordingly.

		jmp	RunV86Task

;---------------

V86_GPF_Handler_INT_imm8:

;------------------------------------------------------------------------------
;Load [Vector] with the immediate byte operand of INT, and reflect interrupt.
;------------------------------------------------------------------------------

                mov     al, @8 GS:[esi+1]               ;=imm8 of INT
		add	@16 [esp0_v86_eip], 2		;adjust IP past INT n
                mov     @8 [Vector], al                 ;imm8 to [Vector]

;V86 SS:SP has already been thunked so do not redo it, but need to subtract
;(2+2+2) from flattened V86 SP ( GS:EBP ).

                lea     ebp, [ebp - (2+2+2)]
                jmp     ReflectInterruptToV86Task_SkipFlattenV86Stack

;===============

V86_GPF_Handler_INT1:
V86_GPF_Handler_INT3:
V86_GPF_Handler_INTO:
V86_GPF_Handler_BOUND:
V86_GPF_Handler_IRETD:
V86_GPF_Handler_POPFD:
V86_GPF_Handler_PUSHFD:

;-------------------------------------------------------------------------------
;Unimplemented in public domain version.
;-------------------------------------------------------------------------------

		jmp	Scheduler_ExitV86Mon_UnexpectedError
